import java.util.*;

public class CollectionTriee implements Collection
{
    private Object[] lesDonnees;
    private int taille = 0;
    
    // Une mthode de recopie
    private Object[] copyOf(Object[] aCopier, int agrandissement) {
        int i;
        Object[] tableauARetourner = new Object [aCopier.length * agrandissement];
        for(i = 0; i < aCopier.length; i++)
            tableauARetourner[i] = aCopier[i];
        return tableauARetourner;
    }
    
    // Les constructeurs
    public CollectionTriee() {
        lesDonnees = new Object[100];
    }

    //
    public String toString()
    {
	String s = "";
	int i;
	for(i = 0; i < taille; i++)
	    s = s + lesDonnees[i] + " ";
	return s;
    }
    
    // Implmentation de l'interface
    public int size()
    {
        return taille;
    }
    
    public boolean isEmpty()
    {
        return taille == 0;
    }
    
    public boolean add(Object arg0) throws UnsupportedOperationException {
        int i = 0, j;
        
        if (arg0 instanceof Comparable)
        {
            // Maintenant il faut chercher ou insrer
           if (isEmpty())
               lesDonnees[0] = arg0;
           else
           {
               if (taille == lesDonnees.length)
                   lesDonnees = copyOf(lesDonnees,2);
               while(i < taille && ((Comparable)lesDonnees[i]).compareTo((Comparable)arg0) < 0)
                   i++;
               for(j=taille; j > i; j--)
                   lesDonnees[j] = lesDonnees[j - 1];
               lesDonnees[i] = arg0;
           }   
           taille++;
           return true;
        }
        else throw new UnsupportedOperationException();
    }
    
    /* (non-Javadoc)
     * @see java.util.Collection#addAll(java.util.Collection)
     */
    public boolean addAll(Collection arg0) {
        // TODO Raccord de mthode auto-gnr
        return false;
    }
    /* (non-Javadoc)
     * @see java.util.Collection#clear()
     */
    public void clear() {
        // TODO Raccord de mthode auto-gnr

    }

    public boolean contains(Object o) {
        int i;
        for(i = 0; i < taille; i++)
            if (lesDonnees[i].equals(o))
                return true;		
        return false;
    }
    /* (non-Javadoc)
     * @see java.util.Collection#containsAll(java.util.Collection)
     */
    public boolean containsAll(Collection arg0) throws IllegalArgumentException {
        int i = 0;
        if (arg0 instanceof CollectionTriee)
        {
            CollectionTriee ct = (CollectionTriee) arg0;
            while (i < ct.taille && contains(ct.lesDonnees[i]))
                i++;
                return (i==ct.taille);            
        }
        throw new IllegalArgumentException("Ce n'est pas un objet de type CollectionTriee");
    }
    
    public Iterator iterator() {
        return new CollectionTrieeIterator(this);
    }
    
    public boolean remove(Object o) {
        throw new UnsupportedOperationException();
    }
    
    public boolean removeAll(Collection arg0) {
        throw new UnsupportedOperationException();             
    }
    
    public boolean retainAll(Collection arg0) {
        throw new UnsupportedOperationException();
    }
    
    public Object[] toArray() {
        return copyOf(lesDonnees,1);
    }
    
    public Object[] toArray(Object[] arg0) {
        throw new UnsupportedOperationException(); 
    }
    
    private static class CollectionTrieeIterator implements Iterator {
        private int position = -1;
        private CollectionTriee ct;
        boolean estCeSupprimable = false;
        
        public CollectionTrieeIterator(CollectionTriee donnee)
        {
            ct = donnee;
        }
        
        public boolean hasNext()
        {
            return position + 1 < ct.taille;
        }
        
        public Object next()
        {
            if (! hasNext())
                throw new NoSuchElementException("hasNext est faux");
            estCeSupprimable = true;
            position++;
            return ct.lesDonnees[position];
        }
        
        public void remove()
        {
            int i;
            if (! estCeSupprimable)
                throw new IllegalStateException("Il y rien a supprimer");
            for(i = position + 1; i < ct.taille; i++)
                ct.lesDonnees[i-1] = ct.lesDonnees[i];
            ct.taille--;
            position--;
            estCeSupprimable = false;
        }
    }
} 
